pipeline {
    agent any

    stages {
        stage('Clone repo') {
            steps {
                git 'git@gitlab.com:darecodeprojects/orange/helloworld.git'
            }
        }
        stage ('Initialize') {
            steps {
                sh '''
                    echo "PATH = ${PATH}"
                    echo "M2_HOME = ${M2_HOME}"
                '''
            }
        }
        stage ('Build Spring Boot Project') {
            steps {
                sh 'mvn -Dmaven.test.failure.ignore=true clean install' 
            }
            post {
                success {
                    junit 'target/surefire-reports/**/*.xml' 
                }
            }
        }
        stage ('Build Docker image') {
            steps {
                sh 'docker build -t helloworld:1.5 .' 
            }
        }
        stage ('Tag & Push') {
            steps {
                sh 'docker tag helloworld:1.5 381337510432.dkr.ecr.eu-west-1.amazonaws.com/helloworld:1.5'
                pushImage()
            }
        }
        stage ('Deploy') {
            steps {
                //deployToKubernetes()
                sh 'kubectl apply -f deployment-definition.yaml -n helloworld'
            }
        }
    }
}


def pushImage() {
    imageName = "381337510432.dkr.ecr.eu-west-1.amazonaws.com/helloworld:1.5"
    image = docker.image(imageName)
    withDockerRegistry(credentialsId: 'ecr:eu-west-1:AWSDarecode', url: 'https://381337510432.dkr.ecr.eu-west-1.amazonaws.com') {
        image.push('1.5')
    }
}

def deployToKubernetes() {
  kubernetesDeploy configs: 'deployment-definition.yaml', kubeConfig: [path: ''], kubeconfigId: 'EKSDarecode', secretName: '', ssh: [sshCredentialsId: '*', sshServer: ''], textCredentials: [certificateAuthorityData: '', clientCertificateData: '', clientKeyData: '', serverUrl: 'https://']
}